using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

public class LogUdpReceiver
{
    static Socket  udpReceiver;
    static IPEndPoint ipPoint;
    static Thread thread;
    public Queue<LogData> logQueues = new Queue<LogData>();

   public LogUdpReceiver(int port)
   {
        ipPoint     = new IPEndPoint(IPAddress.Any, port);            //                 初始化一个侦听局域网内部所有IP和指定端口
        udpReceiver = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp); // 初始化一个Scoket协议
        udpReceiver.Bind(ipPoint); // 绑定这个实例

        //线程接收信息
        thread = new Thread(Receive);
        thread.IsBackground = true;
        thread.Start();
    }
    void Receive()
    {
        EndPoint ep = (EndPoint)ipPoint;

        while (true)
        {
            var buffer = new byte[1024*2];//设置缓冲数据流
            udpReceiver.ReceiveFrom(buffer, ref ep);//接收数据,并确把数据设置到缓冲流里面         

            var str = Encoding.Unicode.GetString(buffer).TrimEnd('\u0000');
            var send = JsonUtility.FromJson<LogData>(str);
            send.ip = ep.ToString();
            logQueues.Enqueue(send);
        }
    }

    public  void Release()
    {
        thread.Abort(); // 终止线程 
        thread = null;

        udpReceiver.Close();
        udpReceiver.Dispose(); // 释放Socket资源 
        udpReceiver = null;

        ipPoint     = null;
    }
}
