using System.Collections;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Text;
using UnityEngine;

public class LogUdpSend
{
    Socket udpSend;
    IPEndPoint ipPoint;


    public LogUdpSend(int port)
    {
        ipPoint = new IPEndPoint(IPAddress.Broadcast, port); // 初始化一个发送广播和指定端口的网络端口实例
        udpSend = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp); // 初始化一个Scoket实习,采用UDP传输 
        udpSend.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1); // 设置该scoket实例的发送形式
    }

    public void Send(LogData msg)
    {
        byte[] buffer = Encoding.Unicode.GetBytes(JsonUtility.ToJson(msg));
        udpSend.SendTo(buffer, ipPoint); // 发送数据
    }

    public void Send(string msg)
    {
        LogData log = new LogData();
        log.msg = msg;
        Send(log);
    } 


    public void Release()
    { 
        udpSend.Close();
        udpSend.Dispose(); // 释放资源 
        udpSend = null;
        
        ipPoint = null;
    }
}
