#if LOGCAT_CLIENT

using System.CodeDom;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LogcatClient : MonoBehaviour
{
    [RuntimeInitializeOnLoadMethod(RuntimeInitializeLoadType.BeforeSceneLoad)]
    static void LogInit()
    {
        isConnect   = false;
        udpSend     = new LogUdpSend(9696);
        udpReceiver = new LogUdpReceiver(9698);
        Application.logMessageReceivedThreaded += LogThread;

        var go = new GameObject("LogcatClient", typeof(LogcatClient));
        DontDestroyOnLoad(go.gameObject);
    }


    static void LogThread(string condition, string stackTrace, LogType type)
    {
        LogData logSend    = new LogData();
        logSend.msg        = condition;
        logSend.stackTrace = stackTrace;
        logSend.logType    = type;

        if (isConnect)
        {
            Send(logSend);
        }
        else
        {
            //大于100的话，丢掉前面的data
            if (logSendQueues.Count > 100)
            {
                logSendQueues.Dequeue();     
            }
            logSendQueues.Enqueue(logSend);
        }
    }


       static bool isConnect  = false;
       static LogUdpReceiver udpReceiver;
       static LogUdpSend     udpSend;
 
       public static Queue<LogData> logSendQueues = new Queue<LogData>();

    // Start is called before the first frame update

    public static void Send(LogData msg)
    {
        udpSend.Send(msg);
    }


    void OnDestroy()
    {
        LogData  data = new LogData();
        data.msg      = "Logcat disconnect";
        udpSend.Send(data);
    }

    // Update is called once per frame
    void Update()
    {
         if(udpReceiver.logQueues.Count>0)
        {
            LogData logSend = udpReceiver.logQueues.Dequeue();

            if (isConnect==false)
            {
                if (logSend.msg.Contains("Logcat listaning"))
                {
                    isConnect = true;
                    udpSend.Send("Logcat connect");
                    udpReceiver.Release();
                }
            }
        }

        if (isConnect)
        {
            if (logSendQueues.Count > 0)
            {
                LogData logSend = logSendQueues.Dequeue();
                Send(logSend);
            }
        }
    }
}
#endif
